////////////////////////////////////////////////////////////////////////
// The NAME_TYPE mechanism is far, far supperior to the CLASS_NAME()
// macro, as it can handle ANY type name.
// It does not have a multi-include guard, as it's usage does not
// call for one.
////////////////////////////////////////////////////////////////////////
#include <string>
#ifndef NAME_TYPE
#    error "You must set both NAME_TYPE and TYPE_NAME before including this supermacro."
#endif // NAME_TYPE

#ifndef TYPE_NAME
#       error "TYPE_NAME must be set if you use NAME_TYPE. Set it to the string form of NAME_TYPE."
#endif

// #include "class_name.h" // for clname namespace suff 

#ifndef CLNAME_INCLUDED
#define CLNAME_INCLUDED 1
// /**
//    The clname namespace contains INTERNAL code for the class_name
//    utility class. DON'T USE IT. 100% experimental.
// */
// namespace clname {
        
//         /** experimental. don't use. */
//         typedef std::map<const std::type_info *,std::string> name_map_type;

//         /** internal marker class */
//         struct classname_sharing_context {}; 

//         /** experimental. don't use. */
//         name_map_type & names_map()
//         {
//                 return s11n::phoenix<name_map_type,classname_sharing_context>::instance();
//         }

//         /** experimental. don't use. */
//         template <typename T>
//         void register_name( const std::string & classname )
//         {
//                 const std::type_info * ti = & typeid((T *)0);
//                 names_map()[ti] = classname;
//         }

//         /** experimental. don't use. */
//         template <typename T>
//         const char * classname( const T * t )
//         {
//                 typedef name_map_type::const_iterator CIT;
//                 const std::type_info * tid = & typeid(t);
//                 CIT cit = names_map().find( tid  );
//                 return (names_map().end() == cit)
//                         ? tid->name() // eeek!
//                         : (*cit).second.c_str();

//         }
// } // namespace clname
#include "class_name.h"
#endif // CLNAME_INCLUDED

namespace {
//         template <typename T> struct class_name;

        template <>
        struct class_name< NAME_TYPE  >
        { 
                static const char * name() { 
                        return TYPE_NAME;
                }
        };
        template <>
        struct class_name< const NAME_TYPE  >
        { 
                static const char * name() { 
                        return TYPE_NAME;
                }
        };
        template <>
        struct class_name< NAME_TYPE *  >
        { 
                static const char * name() { 
                        return TYPE_NAME;
                }
        };

        template <>
        struct class_name< const NAME_TYPE *  >
        { 
                static const char * name() { 
                        return TYPE_NAME;
                }
        };

}
#undef NAME_TYPE
#undef TYPE_NAME

