// don't use this yet. i'm not quite sure what the hell it's really for.
////////////////////////////////////////////////////////////////////////
// Boilerplate code for doing some registration stuff for
// non-Serializables

// It is compatible with ALL types.

// License: Public Domain
// Author: stephan@s11n.net
////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////
// NOTE: this file does not use a conventional BLAH_H_INCLUDED guard.
// Yes, that's on purpose.
////////////////////////////////////////////////////////////////////////
// Boilerplate code for a
// proxies.
//
//
// The s11n header files are expected to have been included by the
// time this file is ever included.
//
//
// Sample usage:
//
// #define NONS11N_TYPE std::map<Foo,Bar>
// #define NONS11N_NAME "std::map<Foo,Bar>"
// #include [this file]
//
// // repeat for each type:
// #define NONS11N_TYPE std::map<Foo *,Bar *>
// #define NONS11N_NAME "std::map<Foo*,Bar*>"
// #include [this file]
//
// If NONS11N_TYPE is a subtype of another Serializable,
// and should be available via that base-type's classloader
// (Yes, you normally WANT this) then define this macro:
//
//   NONS11N_BASE_TYPE
//
// to the type name of NONS11N_TYPE's BaseType base type.
//
// Not setting NONS11N_BASE_TYPE is functionaly identical
// to setting it to NONS11N_TYPE.
//
// After each include all of these macros are unset so that they may
// be immediately re-used for another registration.
////////////////////////////////////////////////////////////////////////


#ifndef NONS11N_TYPE
#    error "NONS11N_TYPE is not set. Set it to the type you want to proxy before including this file!"
#endif

#ifndef NONS11N_NAME
#    error "NONS11N_NAME must be set to the string form of NONS11N_TYPE"
#endif

#ifndef NONS11N_BASE
#    define NONS11N_BASE NONS11N_TYPE
#endif

////////////////////////////////////////////////////////////////////////
// set up the type name registry
#define NAME_TYPE S11N_TYPE
#define TYPE_NAME S11N_NAME
#include <s11n/name_type.h>
////////////////////////////////////////////////////////////////////////

namespace { // anonymous namespace is important for complex linking reasons.

#ifndef s11n_NONS11N_REG_CONTEXT_DEFINED
#define s11n_NONS11N_REG_CONTEXT_DEFINED 1
        ///////////////////////////////////////////////////////////////
        // we must not include this more than once per compilation unit
        ///////////////////////////////////////////////////////////////
        // A unique (per Context/per compilation unit) space to assign
        // a bogus value for classloader registration purposes (see
        // the classloader docs for a full description of how this
        // works).
        template <typename Context >
        struct nons11n_reg_context
        {
                static bool placeholder;
        };
        template <typename Context > bool nons11n_reg_context< Context >::placeholder = false;
        // must be set by specializations^^^
#endif
// !s11n_NONS11N_REG_CONTEXT_DEFINED
////////////////////////////////////////////////////////////////////////////////

        ////////////////////////////////////////////////////////////////////////
        // Register a factory with the classloader (this could be done any
	// number of ways, actually):
	bool nons11n_reg_context< NONS11N_TYPE >::placeholder=
#ifdef NONS11N_ABSTRACT
	        (cllite::register_abstract_base<
                 NONS11N_BASE
#else
	        (cllite::register_factory<
                 NONS11N_BASE ,
                 NONS11N_TYPE
#endif
                 >( ::classname< NONS11N_TYPE >() )
                 ,true);

} // anon namespace 

////////////////////////////////////////////////////////////////////////////////
// end proxy code for [NONS11N_TYPE]
////////////////////////////////////////////////////////////////////////////////
#undef NONS11N_TYPE
#undef NONS11N_NAME
#undef NONS11N_BASE
#ifdef NONS11N_ABSTRACT
#  undef NONS11N_ABSTRACT
#endif
